//Brutal force method inherited from Multipath.java
//find best 3, 4, 5, 6, 7, 8 sites, and find the best of them.
//use combination method

package multipath;

import multipath.*;
import java.text.DecimalFormat;
import java.util.Random;

public class AppBrutalForce extends Multipath {

  public int caseNum;//number of server in each case
  public int [] select;//selected server number
  public double maxValue;//final max speed value
  public int [] maxSelect;//final select server number
  public double [] maxServerSpeed;//final select server speed

  public AppBrutalForce() {
  }

  public void init(int n){
    caseNum=n;
    select=new int [caseNum+1];
    maxSpeed=0;
    maxValue=0;
    maxSelect=new int[caseNum+1];
    maxServerSpeed=new double[caseNum+1];
    rnd = new Random();
    for(int i=1;i<=1000;i++){
      int j=rnd.nextInt();
    }
  }

  public static void main(String[] args) {
    AppBrutalForce bf;
    LoadData.loadData();
    bf = new AppBrutalForce();

    //check server number from 3 to 10
    for(int i=3;i<=10;i++){
      //i server case
      bf.caseNum=i;
      bf.init(bf.caseNum);
      bf.combination(maxServer, bf.caseNum);
      bf.output();
    }
  }

  //generate all combination: m from n
  public void combination(int n, int m){
    int length=n;
    int choose=m;
    String[] elements = new String [length+1];
    for(int i=0;i<length;i++){
      elements[i]=(new Integer(i+1)).toString();
    }
    int[] indices;
    CombinationGenerator x = new CombinationGenerator (length, choose);
    StringBuffer combination;
    while (x.hasMore ()) {
      combination = new StringBuffer ();
      indices = x.getNext ();
      for (int i = 0; i < indices.length; i++) {
        select[i+1]=new Integer(elements[indices[i]]).intValue();
      }
      path();
      updateBest();
    }
  }

  public void updateBest(){
    maxSpeed=0;
    for(int i=1;i<=caseNum;i++){
      maxSpeed += actSpeed[select[i]];
    }
    if(maxSpeed > maxValue){
      maxValue=maxSpeed;
      for(int i=1;i<=caseNum;i++){
        maxSelect[i]=select[i];
        maxServerSpeed[i]=actSpeed[select[i]];
      }
    }
  }

  //calc path avail speed for each server in select[caseNum+1]
  public void path(){
    //init
    for(int i=1;i<=maxServer;i++){
      actSpeed[i]=0;
    }
    for(int i=1;i<=maxPath;i++){
      pathes[i].availSpeed=pathes[i].speed;
    }
    //start update path avail speed for each server in select
    for(int sid=1;sid<=caseNum;sid++){
        updatePath(select[sid]);
    }
  }

  //update available speed of path for server with server number s
  private void updatePath(int s){
    int sid=s;
    boolean pathEnd=false;
    double speed=servers[sid].speed;
    Node fNode=servers[sid].fatherNode;
    Path fPath=findPath(servers[sid],fNode);
    if((fPath.availSpeed - speed)>=0)
      fPath.availSpeed -= speed;
    else
      speed=fPath.availSpeed;

    Node cNode;
    while(!pathEnd){
      cNode=fNode;
      fNode=cNode.fatherNode;
      fPath=findPath(cNode,fNode);
      if((fPath.availSpeed - speed)>0)
        fPath.availSpeed -= speed;
      else{
        speed=fPath.availSpeed;
        fPath.availSpeed=0;
      }

      actSpeed[sid]=speed;
      if(fNode.isEqual(nodes[maxNode]))
        pathEnd=true;
    }
  }

  //final output
  public void output(){
    System.out.print("\nMax Speed for "+caseNum+" servers selection: "+formatNumber(maxValue));
    System.out.print("\nServer Selection: ");
    for(int i=1;i<=caseNum;i++){
        System.out.print("S"+maxSelect[i]+":("+formatNumber(maxServerSpeed[i])+") , ");
    }
  }


  //find a path with start node and end node
  private Path findPath(Node sNode, Node fNode){
    for(int i=1;i<=maxPath;i++){
      if((pathes[i].startNode.isEqual(sNode))&&(pathes[i].endNode.isEqual(fNode)))
        return pathes[i];
    }
    return null;
  }

  //format double number for output
  private static String formatNumber(double number) {
      DecimalFormat myFormatter = new DecimalFormat("#0.00#");
      return myFormatter.format(number);
  }

}