//Brutal force method inherited from Multipath.java
//find best 3, 4, 5, 6, 7, 8 sites, and find the best of them.
//use nested for loop.

package multipath;

import multipath.*;
import java.text.DecimalFormat;
import java.util.Random;

public class AppBrutalForce2 extends Multipath {

  public int caseNum;//number of server in each case
  public int [] select;//selected server number
  public double maxValue;//final max speed value
  public int [] maxSelect;//final select server number
  public double [] maxServerSpeed;//final select server speed

  public AppBrutalForce2() {
  }

  public void init(int n){
    caseNum=n;
    select=new int [caseNum+1];
    maxSpeed=0;
    maxValue=0;
    maxSelect=new int[caseNum+1];
    maxServerSpeed=new double[caseNum+1];
    rnd = new Random();
    for(int i=1;i<=1000;i++){
      int j=rnd.nextInt();
    }
  }

  public static void main(String[] args) {
    AppBrutalForce2 bf;
    LoadData.loadData();
    bf = new AppBrutalForce2();

    //3 server case
    bf.init(3);
    bf.run3();
    bf.output();

    //4 server case
    bf.init(4);
    bf.run4();
    bf.output();

    //5 server case
    bf.init(5);
    bf.run5();
    bf.output();

    //6 server case
    bf.init(6);
    bf.run6();
    bf.output();

    //7 server case
    bf.init(7);
    bf.run7();
    bf.output();

    //8 server case
    bf.init(8);
    bf.run8();
    bf.output();
  }

  //start running for 3 server case
  public void run3(){
    for(int a1=1;a1<=maxServer;a1++){
      select[1]=a1;
      for(int a2=a1+1;a2<=maxServer;a2++){
        select[2]=a2;
        for(int a3=a2+1;a3<=maxServer;a3++){
          select[3]=a3;
          path();
          updateBest();
        }
      }
    }
  }

  //start running for 4 server case
  public void run4(){
    for(int a1=1;a1<=maxServer;a1++){
      select[1]=a1;
      for(int a2=a1+1;a2<=maxServer;a2++){
        select[2]=a2;
        for(int a3=a2+1;a3<=maxServer;a3++){
          select[3]=a3;
          for(int a4=a3+1;a4<=maxServer;a4++){
            select[4]=a4;
            path();
            updateBest();
          }
        }
      }
    }
  }

  //start running for 5 server case
  public void run5(){
    for(int a1=1;a1<=maxServer;a1++){
      select[1]=a1;
      for(int a2=a1+1;a2<=maxServer;a2++){
        select[2]=a2;
        for(int a3=a2+1;a3<=maxServer;a3++){
          select[3]=a3;
          for(int a4=a3+1;a4<=maxServer;a4++){
            select[4]=a4;
            for(int a5=a4+1;a5<=maxServer;a5++){
              select[5]=a5;
              path();
              updateBest();
            }
          }
        }
      }
    }
  }

  //start running for 6 server case
  public void run6(){
    for(int a1=1;a1<=maxServer;a1++){
      select[1]=a1;
      for(int a2=a1+1;a2<=maxServer;a2++){
        select[2]=a2;
        for(int a3=a2+1;a3<=maxServer;a3++){
          select[3]=a3;
          for(int a4=a3+1;a4<=maxServer;a4++){
            select[4]=a4;
            for(int a5=a4+1;a5<=maxServer;a5++){
              select[5]=a5;
              for(int a6=a5+1;a6<=maxServer;a6++){
                select[6]=a6;
                path();
                updateBest();
              }
            }
          }
        }
      }
    }
  }

  //start running for 7 server case
  public void run7(){
    for(int a1=1;a1<=maxServer;a1++){
      select[1]=a1;
      for(int a2=a1+1;a2<=maxServer;a2++){
        select[2]=a2;
        for(int a3=a2+1;a3<=maxServer;a3++){
          select[3]=a3;
          for(int a4=a3+1;a4<=maxServer;a4++){
            select[4]=a4;
            for(int a5=a4+1;a5<=maxServer;a5++){
              select[5]=a5;
              for(int a6=a5+1;a6<=maxServer;a6++){
                select[6]=a6;
                for(int a7=a6+1;a7<=maxServer;a7++){
                  select[7]=a7;
                  path();
                  updateBest();
                }
              }
            }
          }
        }
      }
    }
  }

  //start running for 8 server case
  public void run8(){
    for(int a1=1;a1<=maxServer;a1++){
      select[1]=a1;
      for(int a2=a1+1;a2<=maxServer;a2++){
        select[2]=a2;
        for(int a3=a2+1;a3<=maxServer;a3++){
          select[3]=a3;
          for(int a4=a3+1;a4<=maxServer;a4++){
            select[4]=a4;
            for(int a5=a4+1;a5<=maxServer;a5++){
              select[5]=a5;
              for(int a6=a5+1;a6<=maxServer;a6++){
                select[6]=a6;
                for(int a7=a6+1;a7<=maxServer;a7++){
                  select[7]=a7;
                  for(int a8=a7+1;a8<=maxServer;a8++){
                    select[8]=a8;
                    path();
                    updateBest();
                  }
                }
              }
            }
          }
        }
      }
    }
  }


  public void updateBest(){
    maxSpeed=0;
    for(int i=1;i<=caseNum;i++){
      maxSpeed += actSpeed[select[i]];
    }
    if(maxSpeed > maxValue){
      maxValue=maxSpeed;
      for(int i=1;i<=caseNum;i++){
        maxSelect[i]=select[i];
        maxServerSpeed[i]=actSpeed[select[i]];
      }
    }
  }

  //calc path avail speed for each server in select[caseNum+1]
  public void path(){
    //init
    for(int i=1;i<=maxServer;i++){
      actSpeed[i]=0;
    }
    for(int i=1;i<=maxPath;i++){
      pathes[i].availSpeed=pathes[i].speed;
    }
    //start update path avail speed for each server in select
    for(int sid=1;sid<=caseNum;sid++){
        updatePath(select[sid]);
    }
  }

  //update available speed of path for server with server number s
  private void updatePath(int s){
    int sid=s;
    boolean pathEnd=false;
    double speed=servers[sid].speed;
    Node fNode=servers[sid].fatherNode;
    Path fPath=findPath(servers[sid],fNode);
    if((fPath.availSpeed - speed)>=0)
      fPath.availSpeed -= speed;
    else
      speed=fPath.availSpeed;

    Node cNode;
    while(!pathEnd){
      cNode=fNode;
      fNode=cNode.fatherNode;
      fPath=findPath(cNode,fNode);
      if((fPath.availSpeed - speed)>0)
        fPath.availSpeed -= speed;
      else{
        speed=fPath.availSpeed;
        fPath.availSpeed=0;
      }

      actSpeed[sid]=speed;
      if(fNode.isEqual(nodes[maxNode]))
        pathEnd=true;
    }
  }

  //final output
  public void output(){
    System.out.print("\nMax Speed for "+caseNum+" servers selection: "+formatNumber(maxValue));
    System.out.print("\nServer Selection: ");
    for(int i=1;i<=caseNum;i++){
        System.out.print("S"+maxSelect[i]+":("+formatNumber(maxServerSpeed[i])+") , ");
    }
  }


  //find a path with start node and end node
  private Path findPath(Node sNode, Node fNode){
    for(int i=1;i<=maxPath;i++){
      if((pathes[i].startNode.isEqual(sNode))&&(pathes[i].endNode.isEqual(fNode)))
        return pathes[i];
    }
    return null;
  }

  //format double number for output
  private static String formatNumber(double number) {
      DecimalFormat myFormatter = new DecimalFormat("#0.00#");
      return myFormatter.format(number);
  }

}