//output the possible max speed by brutal force.
//by checking bottleneck from server by server.

package multipath;

import multipath.*;
import java.text.DecimalFormat;
import java.util.Random;

public class AppOptimal extends Multipath{

  public static Random rnd;
  public static int start;

  public AppOptimal() {
    rnd = new Random();
    maxSpeed=0;
    for(int i=1;i<=1000;i++){
      int j=rnd.nextInt();
    }
    start=rnd.nextInt(maxServer) +1;;
  }

  public static void main(String[] args) {
    AppOptimal o;
    LoadData.loadData();
    o = new AppOptimal();
    o.path();
    o.output();
  }

  //final output
  public void output(){
    for(int i=1;i<=maxServer;i++){
      maxSpeed += actSpeed[i];
    }
    System.out.print("\nFinal Possible Max Speed: "+formatNumber(maxSpeed));
    System.out.print("\nServer Selection: ");
    int temp=0;
    for(int i=1;i<=maxServer;i++){
      if(actSpeed[i]!=0){
        temp++;
        System.out.print("S"+i+":("+formatNumber(actSpeed[i])+") , ");
      }
    }
    System.out.print("\nNumber of Server Selected: "+temp);
  }

  //format double number for output
  private static String formatNumber(double number) {
      DecimalFormat myFormatter = new DecimalFormat("#0.00#");
      return myFormatter.format(number);
  }

  //calc path avail speed for each server
  public void path(){
    for(int sid=start;sid<=maxServer;sid++){
        updatePath(sid);
    }
    for(int sid=1;sid<start;sid++){
        updatePath(sid);
    }
  }

  //update available speed of path for each server
  private void updatePath(int s){
    int sid=s;
    boolean pathEnd=false;
    double speed=servers[sid].speed;
    Node fNode=servers[sid].fatherNode;
    Path fPath=findPath(servers[sid],fNode);
    if((fPath.availSpeed - speed)>=0)
      fPath.availSpeed -= speed;
    else
      speed=fPath.availSpeed;

    Node cNode;
    while(!pathEnd){
      cNode=fNode;
      fNode=cNode.fatherNode;
      fPath=findPath(cNode,fNode);
      if((fPath.availSpeed - speed)>0)
        fPath.availSpeed -= speed;
      else{
        speed=fPath.availSpeed;
        fPath.availSpeed=0;
      }

      actSpeed[sid]=speed;
      if(fNode.isEqual(nodes[maxNode]))
        pathEnd=true;
    }
  }

  //find a path with start node and end node
  private Path findPath(Node sNode, Node fNode){
    for(int i=1;i<=maxPath;i++){
      if((pathes[i].startNode.isEqual(sNode))&&(pathes[i].endNode.isEqual(fNode)))
        return pathes[i];
    }
    return null;
  }
}