//Brutal force method inherited from Multipath.java
//find best 3, 4, 5...n sites, and find the best of them.

package multipath;

import multipath.*;
import java.text.DecimalFormat;
import java.util.Random;

public class BrutalForce extends Multipath {

  public BrutalForce() {
  }

  public void init(){
    rnd = new Random();
    maxSpeed=0;
    for(int i=1;i<=1000;i++){
      int j=rnd.nextInt();
    }
    start=rnd.nextInt(maxServer) +1;
  }

  public static void main(String[] args) {
    BrutalForce bf;
      LoadData.loadData();
      bf = new BrutalForce();
      bf.init();
      bf.path();
      bf.output();
  }

  //final output
  public void output(){
    int runtime=1;
    for(int i=1;i<=maxServer;i++){
      maxSpeed += actSpeed[i];
    }
    System.out.print("\nTime "+ runtime+" Final Max Speed: "+formatNumber(maxSpeed));
    System.out.print("\nServers Selected: ");
    for(int i=1;i<=maxServer;i++){
      if(actSpeed[i]!=0)
        System.out.print("Server"+i+" : ("+formatNumber(actSpeed[i])+") , ");
    }
  }

  //format double number for output
  private static String formatNumber(double number) {
      DecimalFormat myFormatter = new DecimalFormat("#0.00#");
      return myFormatter.format(number);
  }

  //calc path avail speed for each server
  public void path(){
//    start=1;
    for(int sid=start;sid<=(start+maxServer-1);sid++){
      if(sid%maxServer!=0)
        updatePath(sid%maxServer);
    }
  }

  //update available speed of path for each server
  private void updatePath(int s){
    int sid=s;
    boolean pathEnd=false;
    double speed=servers[sid].speed;
    Node fNode=servers[sid].fatherNode;
    Path fPath=findPath(servers[sid],fNode);
    if((fPath.availSpeed - speed)>=0)
      fPath.availSpeed -= speed;
    else
      speed=fPath.availSpeed;

    Node cNode;
    while(!pathEnd){
      cNode=fNode;
      fNode=cNode.fatherNode;
      fPath=findPath(cNode,fNode);
      if((fPath.availSpeed - speed)>0)
        fPath.availSpeed -= speed;
      else{
        speed=fPath.availSpeed;
        fPath.availSpeed=0;
      }

      actSpeed[sid]=speed;
      if(fNode.isEqual(nodes[maxNode]))
        pathEnd=true;
    }
  }

  //find a path with start node and end node
  private Path findPath(Node sNode, Node fNode){
    for(int i=1;i<=maxPath;i++){
      if((pathes[i].startNode.isEqual(sNode))&&(pathes[i].endNode.isEqual(fNode)))
        return pathes[i];
    }
    return null;
  }
}