//Loading data, parameter controlling center
//complicate case
package multipath;

import java.util.Random;
/*
//20 nodes , 10 mirror sites
public class LoadData {

  public static void loadData(){
    //control parameters
    Multipath.maxNode=10;
    Multipath.maxPath=19;
    Multipath.maxServer=10;
    Multipath.nodes=new Node[Multipath.maxNode+1];//store all nodes
    Multipath.pathes=new Path[Multipath.maxPath+1];//store all pathes
    Multipath.servers=new Server[Multipath.maxServer+1];//store all servers
    Multipath.actSpeed=new double[Multipath.maxServer+1];//store actual speed from each server
    init();
  }

  //init values
  public static void init(){
    for(int i=1;i<=Multipath.maxNode;i++){
      Multipath.nodes[i]=new Node(i);
    }

    Multipath.servers[1]=new Server(1,10.0);
    Multipath.servers[2]=new Server(2,10.0);
    Multipath.servers[3]=new Server(3,5.0);
    Multipath.servers[4]=new Server(4,5.0);
    Multipath.servers[5]=new Server(5,20);
    Multipath.servers[6]=new Server(6,10.0);
    Multipath.servers[7]=new Server(7,10.0);
    Multipath.servers[8]=new Server(8,15.0);
    Multipath.servers[9]=new Server(9,10.0);
    Multipath.servers[10]=new Server(10,20.0);

    Multipath.pathes[1]=new Path(1,20.0,Multipath.servers[1],Multipath.nodes[1]);
    Multipath.pathes[2]=new Path(2,10.0,Multipath.servers[2],Multipath.nodes[1]);
    Multipath.pathes[3]=new Path(3,5.0,Multipath.servers[3],Multipath.nodes[1]);
    Multipath.pathes[4]=new Path(4,15.0,Multipath.servers[4],Multipath.nodes[2]);
    Multipath.pathes[5]=new Path(5,20,Multipath.servers[5],Multipath.nodes[2]);
    Multipath.pathes[6]=new Path(6,10.0,Multipath.servers[6],Multipath.nodes[3]);
    Multipath.pathes[7]=new Path(7,10.0,Multipath.servers[7],Multipath.nodes[4]);
    Multipath.pathes[8]=new Path(8,15.0,Multipath.servers[8],Multipath.nodes[5]);
    Multipath.pathes[9]=new Path(9,30.0,Multipath.servers[9],Multipath.nodes[5]);
    Multipath.pathes[10]=new Path(10,20.0,Multipath.servers[10],Multipath.nodes[6]);

    Multipath.pathes[11]=new Path(11,66,Multipath.nodes[1],Multipath.nodes[8]);
    Multipath.pathes[12]=new Path(12,124,Multipath.nodes[2],Multipath.nodes[7]);
    Multipath.pathes[13]=new Path(13,130,Multipath.nodes[3],Multipath.nodes[7]);
    Multipath.pathes[14]=new Path(14,27,Multipath.nodes[4],Multipath.nodes[7]);
    Multipath.pathes[15]=new Path(15,41,Multipath.nodes[5],Multipath.nodes[7]);
    Multipath.pathes[16]=new Path(16,66,Multipath.nodes[6],Multipath.nodes[7]);
    Multipath.pathes[17]=new Path(17,44,Multipath.nodes[7],Multipath.nodes[8]);
    Multipath.pathes[18]=new Path(18,86,Multipath.nodes[8],Multipath.nodes[9]);
    Multipath.pathes[19]=new Path(19,63,Multipath.nodes[9],Multipath.nodes[10]);

    Server.calcFatherNode();
    Node.calcFatherNode();
  }
}
*/

/*
//simplest case 10 nodes, 5 mirror sites
package multipath;

public class LoadData {

  public static void loadData(){
    //control parameters
    Multipath.maxNode=4;
    Multipath.maxPath=6;
    Multipath.maxServer=3;
    Multipath.nodes=new Node[Multipath.maxNode+1];//store all nodes
    Multipath.pathes=new Path[Multipath.maxPath+1];//store all pathes
    Multipath.servers=new Server[Multipath.maxServer+1];//store all servers
    Multipath.actSpeed=new double[Multipath.maxServer+1];//store actual speed from each server
    init();
  }

  //init values
  public static void init(){
    for(int i=1;i<=Multipath.maxNode;i++){
      Multipath.nodes[i]=new Node(i);
    }

    Multipath.servers[1]=new Server(1,1.7);
    Multipath.servers[2]=new Server(2,9.4);
    Multipath.servers[3]=new Server(3,5.6);

    Multipath.pathes[1]=new Path(1,1.7,Multipath.servers[1],Multipath.nodes[1]);
    Multipath.pathes[2]=new Path(2,9.4,Multipath.servers[2],Multipath.nodes[1]);
    Multipath.pathes[3]=new Path(3,5.6,Multipath.servers[3],Multipath.nodes[1]);
    Multipath.pathes[4]=new Path(4,66,Multipath.nodes[1],Multipath.nodes[2]);
    Multipath.pathes[5]=new Path(5,86,Multipath.nodes[2],Multipath.nodes[3]);
    Multipath.pathes[6]=new Path(6,3.3,Multipath.nodes[3],Multipath.nodes[4]);

    Server.calcFatherNode();
    Node.calcFatherNode();
  }
}
*/


//virtual case
public class LoadData {

  public static void loadData(){
    //control parameters
    Multipath.maxNode=200;
    Multipath.maxServer=25;

    Multipath.maxPath=Multipath.maxNode+Multipath.maxServer-1;
    Multipath.nodes=new Node[Multipath.maxNode+1];//store all nodes
    Multipath.pathes=new Path[Multipath.maxPath+1];//store all pathes
    Multipath.servers=new Server[Multipath.maxServer+1];//store all servers
    Multipath.actSpeed=new double[Multipath.maxServer+1];//store actual speed from each server
    init();
  }

  //init values
  public static void init(){

    int temp=(new Random()).nextInt(100)+1;
    temp=50;

    for(int i=1;i<=Multipath.maxNode;i++){
      Multipath.nodes[i]=new Node(i);
    }

    for(int i=1;i<=Multipath.maxServer;i++)
    {
      Multipath.servers[i]=new Server(i,10.0+2*i);
      //Multipath.servers[i]=new Server(i,temp/10);
    }

    //path connecting server and node
    for(int i=1;i<=Multipath.maxServer;i++)
    {
      Multipath.pathes[i]=new Path(i,10.0+2*i,Multipath.servers[i],Multipath.nodes[(i/3+1)]);
      //Multipath.pathes[i]=new Path(i,temp/5,Multipath.servers[i],Multipath.nodes[(i/3+1)]);
    }

    //path connecting nodes
    for(int i=1;i<Multipath.maxNode;i++){
      Multipath.pathes[Multipath.maxServer+i]=new Path(Multipath.maxServer+i,(100+2*i)/(3*i),Multipath.nodes[i],Multipath.nodes[Multipath.maxNode-i/10]);
      //Multipath.pathes[Multipath.maxServer+i]=new Path(Multipath.maxServer+i,temp,Multipath.nodes[i],Multipath.nodes[Multipath.maxNode-i/10]);
    }

    Server.calcFatherNode();
    Node.calcFatherNode();
  }
}

/*
//UCCS case
public class LoadData {

  //server data: server speed
  public static int[] serverData=new int[]{0,55,17,55,19,43,67,15,56,54,9,33};
  //path connected to server: path bandwidth: server id
  public static int[] pathData =new int[]{0,55,17,55,19,43,67,15,56,54,9,33};
  public static int[] pathData2=new int[]{0,1,2,3,4,5,6,7,8,9,10,11};
  //path connected to nodes: path bandwidth: node id 1: node id 2
  public static int[] pathNode =new int[]{0,28,90,90,57,29,208,36,36,78,177,203,203,203,84,84,84,84,55,41,39,45,45,361,65,120,35,157,597,53,53,53,57,57,54,54,35,42,42,1216,210,210,256,67,194,194,194,169,169,445,29,275,9984,42,33,57,57,183,148,1237,36,56,15,25,34,35,70,1856,33,33,360,128,512,80,48,331,405,484,52,109,109,3328,3328,114,717,717,296,323,15,675,333,333,2133,5632,591,427,141, 64, 128,108,260};
  public static int[] pathNode2=new int[]{0, 1,12,13,14,15, 16,17,18,19,  2, 21, 22, 23,24,25,26,27, 3,28,29,30,31, 32,33,  4,34, 35,36 ,37,38,39,40,41, 5,42,43,44,45,46,   47, 48, 49, 6,51, 52, 53, 54, 55, 56, 57, 58,50,   7, 59,60,61,62, 63, 64,  65, 8,66,67,68,69,70, 71,  9,72,73, 74, 75, 76,77,78, 79,  80,10, 82, 83,  84,  85, 86, 87, 88, 89, 90,11,91,  92, 93, 94,  95,  96, 97, 81, 20,100,101,102};
  public static int[] pathNode3=new int[]{0,12,13,14,15,16, 17,18,19,20, 21, 22, 23, 24,25,26,27,20,28,29,30,31,32, 33,20, 34,35, 36,37, 38,39,40,41,33,42,43,44,45,46,47,   48, 49, 50,51,52, 53, 54, 55, 56, 57, 58, 50,78,  59,60,61,62,63,64,  65,  58,66,67,68,69,70,71, 78, 72,73,74, 75, 76, 77,71,79, 80,  81,82, 83, 84,  85,  86, 87, 88, 89, 90, 80,91,92,  93, 94, 95,  96,  97, 81,100,100, 101,102,103};

  public static void loadData(){
    //control parameters
    Multipath.maxNode=103;
    Multipath.maxServer=11;
    Multipath.maxPath=Multipath.maxServer+pathNode.length-1;

    Multipath.nodes=new Node[Multipath.maxNode+1];//store all nodes
    Multipath.pathes=new Path[Multipath.maxPath+1];//store all pathes
    Multipath.servers=new Server[Multipath.maxServer+1];//store all servers
    Multipath.actSpeed=new double[Multipath.maxServer+1];//store actual speed from each server
    init();
  }

  //init values
  public static void init(){

    for(int i=1;i<=Multipath.maxNode;i++){
      Multipath.nodes[i]=new Node(i);
    }

    for(int i=1;i<=Multipath.maxServer;i++)
    {
      Multipath.servers[i]=new Server(i,serverData[i]);
    }

    //path connecting server and node
    for(int i=1;i<=Multipath.maxServer;i++)
    {
      Multipath.pathes[i]=new Path(i,pathData[i],Multipath.servers[i],Multipath.nodes[(pathData2[i])]);
    }

    //path connecting nodes
    for(int i=1;i<pathNode.length;i++){
      Multipath.pathes[Multipath.maxServer+i]=new Path(Multipath.maxServer+i,pathNode[i],Multipath.nodes[pathNode2[i]],Multipath.nodes[pathNode3[i]]);
    }

    Server.calcFatherNode();
    Node.calcFatherNode();
  }
}
)*/